using UnityEngine;

public class MinEventActionGlubsGiveExp : MinEventActionRemoveBuff //All players have a buff that triggers this 2.5 seconds (~every in-game minute)
{
    public override void Execute(MinEventParams _params)
    {
        ulong worldTime = GameManager.Instance.World.worldTime;
        float BaseExpToLevel = Progression.BaseExpToLevel;
        float ExpMultiplier = Progression.ExpMultiplier;
        int minutes = (int)(worldTime * 0.06 - 7 * 60); // number of minutes since 7am on day 1
        for (int i = 0; i < this.targets.Count; i++)
        {
            EntityPlayerLocal entity = this.targets[i] as EntityPlayerLocal;
            if (entity != null)
            {
                if (entity.Progression.Level <= Progression.MaxLevel)
                {
                    // int bonusexp = (int)(3*Mathf.Floor((worldTime-240)/10080))
                    // int deaths = 0;
                    // foreach (EntityPlayer player in GameManager.Instance.World.Players.list)// this list is only of active players
                    // {
                        // deaths += XUiM_Player.GetDeaths(player);
                    // };
                    // int progress = (int)(minutes - 180 * deaths);
                    // int progress = (int)(minutes);
                    int ExpToNextLevel = (int)Mathf.Max((BaseExpToLevel * (1.0f - Mathf.Pow(ExpMultiplier, entity.Progression.Level)) / (1.0f - ExpMultiplier) - minutes),0f); //Geometric Series (accounts for total xp for all levels)
                    entity.Progression.ExpToNextLevel = ExpToNextLevel;
					if (ExpToNextLevel <= 0)
                    {
						entity.Progression.AddLevelExp(-1 * ExpToNextLevel);//triggers normal level-up stuff
					}
                }
            }
        }
    }
}






